nodes = [
  { :hostname => 'master', :box => 'hashicorp/bionic64', :ram => 512 },
  { :hostname => 'worker1', :box => 'hashicorp/bionic64'},
  { :hostname => 'worker2', :box => 'hashicorp/bionic64'}
]

Vagrant.configure("2") do |config|
  nodes.each do |node|
    config.vm.define node[:hostname] do |nodeconfig|
      nodeconfig.vm.box = "hashicorp/bionic64"
      nodeconfig.vm.hostname = node[:hostname] + ".box"

      memory = node[:ram] ? node[:ram] : 256;
      nodeconfig.vm.provider :virtualbox do |vb|
        vb.customize [
          "modifyvm", :id,
          "--cpuexecutioncap", "50",
          "--memory", memory.to_s,
        ]
      end
      nodeconfig.vm.provision "ansible" do |ansible|
        ansible.verbose = "v"
        ansible.playbook = "playbook.yml"
      end
    end
  end
end